import java.util.concurrent.Semaphore;
/**
* Simulate custumer behaviors with Semaphore.
*/
public class CustomerSemaphore extends Thread {
    
private Semaphore freeChairs_, busyChairs_, barberChair_;

public CustomerSemaphore(String name, Semaphore freeChairs, Semaphore busyChairs, Semaphore barberChair) {
    super(name);
    this.freeChairs_ = freeChairs;
    this.busyChairs_ = busyChairs;
    this.barberChair_ = barberChair;
}
/* 
* (non-Javadoc)
*
* @see java.lang.Runnable#run()
*/
public void run() {
    try {
    while (!freeChairs_.tryAcquire())
        // Try to take a place in barbershop
        sleep(5000); // Go to pub drink a cup of coffee
        System.out.println(getName() + " Cool ! get a place");
        busyChairs_.release();
        System.out.println(getName() + "Waiting for barber...");
        barberChair_.acquire();
        freeChairs_.release();
    } catch (Exception e) {
    e.printStackTrace();
    System.out.println(getName() + "Interrupted during haircut");
    }
}
}