import java.util.concurrent.Semaphore;
public class Seance{
    public static void main(String[] args) {
    //read command-line arguments
    if (args.length != 2) {
    System.err.println("usage: BarberSemaphore nbChairs nbCustomers");
    System.exit(1);
    }
    int nbChairs = Integer.parseInt(args[0]);
    int nbCustomers = Integer.parseInt(args[1]);
                
    System.err.println("Starting BarberSemaphore with " + nbChairs
    + " chairs and " + nbCustomers + " customers");
    // Initialize Semaphore
    Semaphore freeChairs = new Semaphore(nbChairs);
    Semaphore busyChairs = new Semaphore(0);
    Semaphore barberChair = new Semaphore(0);
    // Create barber thread
    BarberSemaphore c = new BarberSemaphore(busyChairs, barberChair);
    c.start();
    // Create customers threads
    for (int i = 0; i < nbCustomers; i++) {
        CustomerSemaphore customer = new CustomerSemaphore("Client " + i + ":",
        freeChairs, busyChairs, barberChair);
        customer.start();
    }
    }   
}
